//////////////////////////////////////////////////////////////////////////////
//
// (C) Copyright Vicente J. Botet Escriba 2008. Distributed under the Boost
// Software License, Version 1.0. (See accompanying file
// LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
//
// See http://www.boost.org/libs/sync for documentation.
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __BOOST_SYNC_THREAD_SYNCHRONIZATION_FAMILY__HPP
#define __BOOST_SYNC_THREAD_SYNCHRONIZATION_FAMILY__HPP

#include "boost/thread/mutex.hpp"
#include "boost/thread/recursive_mutex.hpp"
#include "boost/thread/shared_mutex.hpp"

namespace boost {
namespace sync {

//!Describes thread synchronization family to use with Sync framework 
//!based on boost synchronization objects.
struct thread_synchronization_family
{
   typedef boost::mutex                 	mutex_type;
   typedef boost::recursive_mutex       	recursive_mutex_type;
   typedef boost::timed_mutex       		timed_mutex_type;
   typedef boost::recursive_timed_mutex     recursive_timed_mutex_type;
   typedef boost::shared_mutex              shared_mutex_type;
   typedef boost::condition_variable_any    condition_type;
};



}
}

#endif
